PKIXRevocationChecker.Option (Java SE 21 & JDK 21)
Description: declaration: module: java.base, package: java.security.cert, class: PKIXRevocationChecker, enum: Option
Keywords: java.security.cert.PKIXRevocationChecker.Option class

Module java.base
Package java.security.cert

# Enum Class PKIXRevocationChecker.Option

java.lang.Object
java.lang.Enum<PKIXRevocationChecker.Option>
java.security.cert.PKIXRevocationChecker.Option

All Implemented Interfaces:
  `Serializable`, `Comparable<PKIXRevocationChecker.Option>`, `Constable`

Enclosing class:
  `PKIXRevocationChecker`

public static enum PKIXRevocationChecker.Option extends Enum<PKIXRevocationChecker.Option>
Various revocation options that can be specified for the revocation checking mechanism.

- ## Nested Class Summary

  ## Nested classes/interfaces declared in class java.lang.Enum

  `Enum.EnumDesc<E extends Enum<E>>`

- ## Enum Constant Summary

  Enum Constants
  Enum Constant
  Description
  `NO_FALLBACK`
  Disable the fallback mechanism.
  `ONLY_END_ENTITY`
  Only check the revocation status of end-entity certificates.
  `PREFER_CRLS`
  Prefer CRLs to OSCP.
  `SOFT_FAIL`
  Allow revocation check to succeed if the revocation status cannot be determined for one of the following reasons: The CRL or OCSP response cannot be obtained because of a network error.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static PKIXRevocationChecker.Option`
  `valueOf(String name)`
  Returns the enum constant of this class with the specified name.
  `static PKIXRevocationChecker.Option[]`
  `values()`
  Returns an array containing the constants of this enum class, in the order they are declared.

  ### Methods declared in class java.lang.Enum

  `clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

  ### Methods declared in class java.lang.Object

  `getClass, notify, notifyAll, wait, wait, wait`

- ## Enum Constant Details

  - ### ONLY_END_ENTITY

    public static final PKIXRevocationChecker.Option ONLY_END_ENTITY
    Only check the revocation status of end-entity certificates.

  - ### PREFER_CRLS

    public static final PKIXRevocationChecker.Option PREFER_CRLS
    Prefer CRLs to OSCP. The default behavior is to prefer OCSP. Each PKIX implementation should document further details of their specific preference rules and fallback policies.

  - ### NO_FALLBACK

    public static final PKIXRevocationChecker.Option NO_FALLBACK
    Disable the fallback mechanism.

  - ### SOFT_FAIL

    public static final PKIXRevocationChecker.Option SOFT_FAIL
    Allow revocation check to succeed if the revocation status cannot be determined for one of the following reasons:
    - The CRL or OCSP response cannot be obtained because of a network error.
    - The OCSP responder returns one of the following errors specified in section 2.3 of RFC 2560: internalError or tryLater.
    Note that these conditions apply to both OCSP and CRLs, and unless the `NO_FALLBACK` option is set, the revocation check is allowed to succeed only if both mechanisms fail under one of the conditions as stated above. Exceptions that cause the network errors are ignored but can be later retrieved by calling the `getSoftFailExceptions` method.

- ## Method Details

  - ### values

    public static PKIXRevocationChecker.Option[] values()
    Returns an array containing the constants of this enum class, in the order they are declared.
    Returns:
      an array containing the constants of this enum class, in the order they are declared

  - ### valueOf

    public static PKIXRevocationChecker.Option valueOf(String name)
    Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)
    Parameters:
      `name` - the name of the enum constant to be returned.
    Returns:
      the enum constant with the specified name
    Throws:
      `IllegalArgumentException` - if this enum class has no constant with the specified name
      `NullPointerException` - if the argument is null